(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)













(* :Name:  Unit` *)



(*
The package Unit` grants an elegant method to work with units. It uses the definition of Mathematica standard packages Miscellaneous`Units` , Miscellaneous`SIUnits`, and Miscellaneous`PhysicalConstants` and expands its definitions to give:
1. Compact typing and reading of units 5\[SmallCircle]kg
2. Unit transformation rules \!\(\(\((2\[SmallCircle]kg)\)\^2\) 3\[SmallCircle]m\[LongRightArrow]12\[SmallCircle]kg\^2\ m\)
3. Subscripts might be used as symbols \!\(TraditionalForm\`1\[SmallCircle]N\_A\) 
4. Work with fundamental constants as with units
5. Evaluation protection of units, so unit m in expression m=1; length=1\[SmallCircle]m is treated correctly
6. The results are presented in globally defined format which can be easily changed
7. The ability of incorporation a set of notation for units of specific field of research
*)



(* :Copyright: 2007 by Yuri E. Kandrashkin *)

(* http://SpinAlgebra.com *)



(* License *)

(*
The program is distributed AS IS and its author is not liable for any data loss, damages, loss of profits or any other kind of loss while using or misusing this software. You may use this product freely for personal purposes. You may not use this software with commercial purposes, i.e. get any profit from its use, without prior consent of the author. You may copy and or distribute this product without any restrictions, provided that the product is not modified.
*)



(* :History: *)

Unit`Private`$Version = "Version 1.0   Apr 2, 2007"



Scan[Needs,{"Miscellaneous`Units`","Miscellaneous`PhysicalConstants`"}]

Unit`UnitFormat["SI"]:=SI
Unit`UnitFormat["MKS"]:=MKS
Unit`UnitFormat["CGS"]:=CGS

Unit`UnitFormat["SIAcronym"]:=
  {{HoldPattern[A]\[Rule]Ampere,HoldPattern[Bq]\[Rule]Becquerel,
      HoldPattern[cd]\[Rule]Candela,HoldPattern[C]\[Rule]Coulomb,
      HoldPattern[F]\[Rule]Farad,HoldPattern[H]\[Rule]Henry,
      HoldPattern[Hz]\[Rule]Hertz,HoldPattern[J]\[Rule]Joule,
      HoldPattern[K]\[Rule]Kelvin,HoldPattern[kg]\[Rule]Kilogram,
      HoldPattern[lm]\[Rule]Lumen,HoldPattern[lx]\[Rule]Lux,
      HoldPattern[m]\[Rule]Meter,HoldPattern[mol]\[Rule]Mole,
      HoldPattern[N]\[Rule]Newton,HoldPattern[\[CapitalOmega]]\[Rule]Ohm,
      HoldPattern[Pa]\[Rule]Pascal,HoldPattern[rad]\[Rule]Radian,
      HoldPattern[s]\[Rule]Second,HoldPattern[S]\[Rule]Siemens,
      HoldPattern[T]\[Rule]Tesla,HoldPattern[V]\[Rule]Volt,
      HoldPattern[W]\[Rule]Watt,HoldPattern[Wb]\[Rule]Weber},
    {Ampere\[RuleDelayed]A,Becquerel\[RuleDelayed]Bq,Candela\[RuleDelayed]cd,
      Coulomb\[RuleDelayed]C,Farad\[RuleDelayed]F,Henry\[RuleDelayed]H,
      Hertz\[RuleDelayed]Hz,Joule\[RuleDelayed]J,Kelvin\[RuleDelayed]K,
      Kilogram\[RuleDelayed]kg,Lumen\[RuleDelayed]lm,Lux\[RuleDelayed]lx,
      Meter\[RuleDelayed]m,Mole\[RuleDelayed]mol,Newton\[RuleDelayed]N,
      Ohm\[RuleDelayed]\[CapitalOmega],Pascal\[RuleDelayed]Pa,
      Radian\[RuleDelayed]rad,Second\[RuleDelayed]s,Siemens\[RuleDelayed]S,
      Tesla\[RuleDelayed]T,Volt\[RuleDelayed]V,Watt\[RuleDelayed]W,
      Weber\[RuleDelayed]Wb}}

\!\(\*
  RowBox[{\(Unit`UnitFormat["\<SIConstants\>"]\), ":=", "\[IndentingNewLine]", 
    RowBox[{"Join", "@@@", 
      RowBox[{"Transpose", "[", 
        RowBox[{"{", "\[IndentingNewLine]", 
          RowBox[{\(Unit`UnitFormat["\<SIAcronym\>"]\), ",", "\[IndentingNewLine]", 
            RowBox[{"{", 
              RowBox[{
                RowBox[{"{", 
                  RowBox[{\(HoldPattern[c] \[Rule] SpeedOfLight\), ",", "\[IndentingNewLine]", \(HoldPattern[\[Mu]\_0] \[Rule] VacuumPermeability\), ",", "\[IndentingNewLine]", \(HoldPattern[\[CurlyEpsilon]\_0] \[Rule] VacuumPermittivity\), ",", "\[IndentingNewLine]", 
                    RowBox[{\(HoldPattern[\[HBar]]\), "\[Rule]", 
                      StyleBox["PlanckConstantReduced",
                        GridBoxOptions->{RowSpacings->0.4,
                        RowLines->False}]}], 
                    StyleBox[",",
                      GridBoxOptions->{RowSpacings->0.4,
                      RowLines->False}], 
                    StyleBox["\[IndentingNewLine]",
                      GridBoxOptions->{RowSpacings->0.4,
                      RowLines->False}], \(HoldPattern[e] \[Rule] ElectronCharge\), ",", "\[IndentingNewLine]", \(HoldPattern[m\_e] \[Rule] ElectronMass\), ",", "\[IndentingNewLine]", \(HoldPattern[m\_p] \[Rule] ProtonMass\), ",", "\[IndentingNewLine]", \(HoldPattern[m\_n] \[Rule] NeutronMass\), ",", "\[IndentingNewLine]", \(HoldPattern[N\_A] \[Rule] AvogadroConstant\), ",", "\[IndentingNewLine]", \(HoldPattern[k] \[Rule] BoltzmannConstant\), ",", "\[IndentingNewLine]", \(HoldPattern[F] \[Rule] FaradayConstant\), ",", "\[IndentingNewLine]", \(HoldPattern[R] \[Rule] MolarGasConstant\), ",", "\[IndentingNewLine]", \(HoldPattern[\[Alpha]] \[Rule] FineStructureConstant\), ",", "\[IndentingNewLine]", \(HoldPattern[a\_0] \[Rule] BohrRadius\), ",", "\[IndentingNewLine]", \(HoldPattern[R\_\[Infinity]] \[Rule] RydbergConstant\), ",", "\[IndentingNewLine]", \(HoldPattern[\[Lambda]\_c] \[Rule] ElectronComptonWavelength\), ",", "\[IndentingNewLine]", \(HoldPattern[\[Mu]\_B] \[Rule] ElectronCharge\ PlanckConstantReduced/\((2  ElectronMass)\)\), ",", "\[IndentingNewLine]", \(HoldPattern[\[Mu]\_e] \[Rule] ElectronMagneticMoment\), ",", "\[IndentingNewLine]", \(HoldPattern[g\_e] \[Rule] ElectronGFactor\), ",", "\[IndentingNewLine]", \(HoldPattern[\[Mu]\_p] \[Rule] ProtonMagneticMoment\), ",", "\[IndentingNewLine]", \(HoldPattern[G] \[Rule] GravitationalConstant\), ",", "\[IndentingNewLine]", \(HoldPattern[g\_n] \[Rule] AccelerationDueToGravity\)}], "}"}], ",", "\[IndentingNewLine]", \({}\)}], "}"}]}], "}"}], "]"}]}]}]\)

\!\(\(Unit`UnitFormat["\<SIFundamental\>"] := \[IndentingNewLine]{{HoldPattern[kg] \[RuleDelayed] Kilogram, \[IndentingNewLine]HoldPattern[m] \[RuleDelayed] Meter, \[IndentingNewLine]HoldPattern[s] \[RuleDelayed] Second, \[IndentingNewLine]HoldPattern[K] \[RuleDelayed] Kelvin, \[IndentingNewLine]HoldPattern[A] \[RuleDelayed] Ampere, \[IndentingNewLine]HoldPattern[mol] \[RuleDelayed] Mole, \[IndentingNewLine]HoldPattern[cd] \[RuleDelayed] Candela, \[IndentingNewLine]HoldPattern[rad] \[RuleDelayed] Radian, \[IndentingNewLine]HoldPattern[sr] \[RuleDelayed] Steradian, \[IndentingNewLine]HoldPattern[Hz] \[RuleDelayed] Hertz, \[IndentingNewLine]Hertz \[RuleDelayed] s\^\(-1\), \[IndentingNewLine]HoldPattern[N] \[RuleDelayed] Newton, \[IndentingNewLine]Newton \[RuleDelayed] m\ kg\ s\^\(-2\), \[IndentingNewLine]HoldPattern[Pa] \[RuleDelayed] Pascal, \[IndentingNewLine]Pascal \[RuleDelayed] m\^\(-1\)\ kg\ s\^\(-2\), \[IndentingNewLine]HoldPattern[J] \[RuleDelayed] Joule, \[IndentingNewLine]Joule \[RuleDelayed] m\^2\ kg\ s\^\(-2\), \[IndentingNewLine]HoldPattern[W] \[RuleDelayed] Watt, \[IndentingNewLine]Watt \[RuleDelayed] m\^2\ kg\ s\^\(-3\), \[IndentingNewLine]HoldPattern[C] \[RuleDelayed] Coulomb, \[IndentingNewLine]Coulomb \[RuleDelayed] A\ s, \[IndentingNewLine]HoldPattern[V] \[RuleDelayed] Volt, \[IndentingNewLine]Volt \[RuleDelayed] m\^2\ kg\ s\^\(-3\)\ A\^\(-1\), \[IndentingNewLine]HoldPattern[\[CapitalOmega]] \[RuleDelayed] Ohm, \[IndentingNewLine]Ohm \[RuleDelayed] m\^2\ \ kg\ s\^\(-3\)\ A\^\(-2\), \[IndentingNewLine]HoldPattern[S] \[RuleDelayed] Siemens, \[IndentingNewLine]Siemens \[RuleDelayed] m\^\(-2\)\ \ kg\^\(-1\)\ s\^3\ A\^2, \[IndentingNewLine]HoldPattern[F] \[RuleDelayed] Farad, \[IndentingNewLine]Farad \[RuleDelayed] m\^\(-2\)\ \ kg\^\(-1\)\ s\^4\ A\^2, \[IndentingNewLine]HoldPattern[Wb] \[RuleDelayed] Weber, \[IndentingNewLine]Weber \[RuleDelayed] m\^2\ \ kg\ s\^\(-2\)\ A\^\(-1\), \[IndentingNewLine]HoldPattern[T] \[RuleDelayed] Tesla, \[IndentingNewLine]Tesla \[RuleDelayed] kg\ s\^\(-2\)\ A\^\(-1\), \[IndentingNewLine]HoldPattern[H] \[RuleDelayed] Henry, \[IndentingNewLine]Henry \[RuleDelayed] m\^2\ \ kg\ s\^\(-2\)\ A\^\(-2\), \[IndentingNewLine]HoldPattern[lm] \[RuleDelayed] Lumen, \[IndentingNewLine]Lumen \[RuleDelayed] cd\ sr, \[IndentingNewLine]HoldPattern[lx] \[RuleDelayed] Lux, \[IndentingNewLine]Lux \[RuleDelayed] cd\ sr\ m\^\(-2\), \[IndentingNewLine]HoldPattern[Bq] \[RuleDelayed] Becquerel, \[IndentingNewLine]Becquerel \[RuleDelayed] s\^\(-1\)}, \[IndentingNewLine]{Meter \[RuleDelayed] m, \[IndentingNewLine]Kilogram \[RuleDelayed] kg, \[IndentingNewLine]Second \[RuleDelayed] s, \[IndentingNewLine]Kelvin \[RuleDelayed] K, \[IndentingNewLine]Ampere \[RuleDelayed] A, \[IndentingNewLine]Mole \[RuleDelayed] mol, \[IndentingNewLine]Candela \[RuleDelayed] cd, \[IndentingNewLine]Radian \[RuleDelayed] rad, \[IndentingNewLine]Steradian \[RuleDelayed] sr}};\)\)

Unit`$UnitFormat="SI"



BeginPackage["Unit`",{"Miscellaneous`Units`",
    "Miscellaneous`PhysicalConstants`"}]

UnitFormat::"usage"=
  "The argument arg of definition UnitFormat[\"format\"]={{inrules},{outrules}} used to set $UnitFormat=\"arg\".\nThe rules used to convert input expression in SI units and result of computation to \"format\"."

$UnitFormat::"usage"=
  "$UnitFormat=\"format\" is a global variable of package Unit`."

Unit::"usage"="a Unit[kg] \[DoubleLongLeftRightArrow] a\[SmallCircle]kg"

UnitUpdate::"usage"=
  "UnitUpdate updates the information of function Unit according to the value of $UnitFormat"

SmallCircle::"usage"=
  "Symbol \"\[SmallCircle]\" used by package Unit` to separate the value and units in the expression"

Begin["`Private`"]





Unit::"fmt"="The function UnitFormat for argument `1` is undefined."

MakeExpression[RowBox[{a__,"\[SmallCircle]",b_}],form_]:=
  MakeExpression[RowBox[{a,"Unit","[",b,"]"}],form]
MakeExpression[SmallCircle[a_,b_],form_]:=
    MakeExpression[RowBox[{a,"Unit","[",b,"]"}],form];
MakeBoxes[Times[a___,Unit[b_],c___],form_]:=
    RowBox[{ToBoxes[Times[a,c],form],"\[SmallCircle]",MakeBoxes[b,form]}];
MakeBoxes[Unit[b_],form_]:=RowBox[{"1","\[SmallCircle]",MakeBoxes[b,form]}];

SetAttributes[Unit,{HoldAll}]

\!\(Unit /: a___\ Unit[b_] c___\ Unit[d_]\ e___ := a\ c\ e\ unit[b\ d]\[IndentingNewLine]
  Unit /: Unit[a_]\^n_ := unit[a\^n]\)

SetAttributes[{unit,holdUnit},{HoldAll}]

unit[a_]:=
  Module[{$outFormat,$inFormat,inRules,outRules,rulesQ,expr,formalVars},
    $inFormat=Switch[$UnitFormat,_List,$UnitFormat,_,{$UnitFormat}];
    $outFormat=First@$inFormat;
    If[MatchQ[$inFormat,{_,All}],$inFormat=
        Part[#,1,1,1]&/@DownValues[UnitFormat]];
    inRules=First/@Cases[UnitFormat/@$inFormat,{{___},{___}},{1}];
    outRules=UnitFormat[$outFormat];
    rulesQ=MatchQ[outRules,{{___},{___}}];
    If[rulesQ,outRules=Last@outRules];
    expr=holdUnit[a];
    expr=Fold[replaceAllButSubscript[ReplaceRepeated,##]&,expr,inRules];
    formalVars=If[rulesQ,Append[expr,outRules],expr];
    formalVars=
      Union[DeleteCases[
          formalVars//.holdUnit[x___,_[y___],z___]\[RuleDelayed]
              holdUnit[x,y,z],_?NumberQ|_String,\[Infinity]]];
    Apply[Block,formalVars/.holdUnit[x__]\[RuleDelayed]
          holdUnit[{Unit,Subscript,x},
            expr=Unit[Times@@expr];
            expr=If[rulesQ,
                replaceAllButSubscript[ReplaceRepeated,expr,outRules],
                If[Head[outRules]=!=UnitFormat,
                  outRules[expr],
                  Message[Unit::"fmt",InputForm[$UnitFormat]]]];
            
            expr//.Unit[Times[y_?NumberQ,z__]]\[RuleDelayed]y Unit[Times[z]]/.

                
                
                Unit[Times[z_]]\[RuleDelayed]
                  Unit[z]/.{Unit[z_?NumberQ]\[RuleDelayed]z,Unit[]\[Rule]1}]]]

replaceAllButSubscript[h:(ReplaceAll|ReplaceRepeated),expr_,rules_]:=
  Block[{Subscript,Message},
    SetAttributes[Subscript,HoldAll];
    Module[{rul1,rul2,x},
      Remove["Unit`Private`xxx*"];
      rul1=rul2={};
      (x=Unique["Unit`Private`xxx"];AppendTo[rul1,#\[Rule]x];
            AppendTo[rul2,x\[Rule] #])&/@
        Cases[{expr,rules},_Subscript,\[Infinity]];
      h[expr/.rul1,rules/.rul1]/.rul2]]



UnitUpdate[expr_]:=expr/.Unit[a_]\[RuleDelayed]unit[a]
UnitUpdate[expr_,form_]:=
  Block[{$UnitFormat=form},expr/.Unit[a_]\[RuleDelayed]unit[a]]



End[]
EndPackage[]

SetAttributes[{Unit,UnitUpdate},{ReadProtected,Protected}]
SetAttributes[{UnitFormat},{Protected}]